﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaction logic for WReplace.xaml
    /// </summary>
    public partial class WReplace : Window {
        private static List<String> listeSearch = new List<String>();
        private static List<String> listeReplace = new List<String>();
        private String search = "";
        private String replace = "";


        private Boolean result = false;

        public Boolean Result {
            get { return result; }
        }
        public String SearchString {
            get { return search; }
        }

        public String ReplaceString {
            get { return replace; }
        }

        public Boolean IgnoreCase {
            get { return chkIgnoreCase.IsChecked == true; }
        }

        public Boolean Wholeword {
            get { return chkWholeWord.IsChecked == true; }
        }


        public WReplace(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            // WindowStartupLocation="CenterOwner"
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            foreach (String s in listeSearch) {
                cbSearchText.Items.Add(s);
            }
            foreach (String s in listeReplace) {
                cbReplaceText.Items.Add(s);
            }
            cbSearchText.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            search = cbSearchText.Text;
            replace = cbReplaceText.Text;

            listeSearch.Clear();
            foreach (String s in cbSearchText.Items) {
                listeSearch.Add(s);
            }
            if (cbSearchText.SelectedIndex < 0) {
                listeSearch.Add(search);
            }

            listeReplace.Clear();
            foreach (String s in cbReplaceText.Items) {
                listeReplace.Add(s);
            }
            if (cbReplaceText.SelectedIndex < 0) {
                listeReplace.Add(replace);
            }
            result = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }
    }
}
