﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Microsoft.Win32;
using System.IO;

namespace HtmlWpfRtf {
    /// <summary>
    /// Interaktionslogik für FCoords.xaml
    /// </summary>
    public partial class WCoords : Window {

        private const int C_POINT = 1;
        private const int C_RECTANGLE = 2;
        private const int C_CIRCLE = 3;
        private const int C_POLYLINE = 4;

        private string filename = "";

        private bool bRetCode = false;

        public bool Retcode {
            get { return bRetCode; }
        }

        //private bool _bStart = false;
        //private bool bInsertCoords=false; 

        private int anzCoords = 0;
        private string sPoints;
        private int xCoord = 0;
        private int yCoord = 0;

        private int CoordsTyp = 0;

        private bool start = true;
        public string getCoords() {
            switch (CoordsTyp) {
                case C_POINT: return "<area shape=\"point\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_RECTANGLE: return "<area shape=\"rect\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_CIRCLE: return "<area shape=\"circle\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                case C_POLYLINE: return "<area shape=\"poly\" alt=\"alt-text\" coords=\"" + sPoints + "\" href=\"ref.html\" />";
                default: return "Error in Case getCoords";
            }
        }

        public WCoords() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            CommandBindings.Add(new CommandBinding(MyCommands.Openfile, OpenExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Close, CloseExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Savefile, SavefileExecuted));
            

            cbZoom.SelectedIndex = 2;
            start = false;
            String filename = Basis.ReadRegString(SingVar.C_REG_ADR, "coords_filename");
            if (File.Exists(filename)) {
                loadImageFile(filename);
            }
        }

        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = true;
        }

        private void OpenExecuted(object sender, ExecutedRoutedEventArgs e) {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "PNG-Files (*.png)|*.png|" +
                                      "JPG-Files (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
                                     "BMP-Files (*.bmp)|*.bmp|" +
                                      "GIF-Files (*.gif)|*.gif|" +
                                      "All Pictures (*.png;*.jpg;*.jpeg;*.bmp;*.gif)|*.png;*.jpg;*.jpeg;*.bmp;*.gif|" +
                                      "All files (*.*)|*.*";

            openFileDialog.FilterIndex = 1;// zählt von 1 !
            openFileDialog.DefaultExt = ".png";
            openFileDialog.InitialDirectory = SingVar.LastPath;
            openFileDialog.Multiselect = false;
            openFileDialog.RestoreDirectory = true;
            openFileDialog.Title = "Open image file";

            if (openFileDialog.ShowDialog() == true) {            
                Basis.WriteRegString(SingVar.C_REG_ADR, "coords_filename", openFileDialog.FileName);
                loadImageFile(openFileDialog.FileName);


            }
        }

        private double getZoomScale() {
            switch (cbZoom.SelectedIndex) {
                case 0: return 0.50;
                case 1: return 0.70;
                case 2: return 1.00;
                case 3: return 2.00;
                case 4: return 3.00;
                case 5: return 4.00;
                case 6: return 5.00;
                case 7: return 6.00;
                case 8: return 7.00;
                case 9: return 8.00;
                default: return 1.0;
            }
        }

        private void loadImageFile(String filename) {
            this.filename = filename;
            BitmapImage btImage = new BitmapImage();
            btImage.BeginInit();
            btImage.UriSource = new Uri(filename, UriKind.Absolute);
            btImage.EndInit();

            image.Width = btImage.Width * getZoomScale();
            image.Height = btImage.Height * getZoomScale();
            image.Stretch = Stretch.Uniform;

            image.Source = btImage;

            anzCoords = 0;
            sPoints = "";
      }


        private void cbZoom_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            if (start) return;
            loadImageFile(filename);
            //BitmapImage btImage = new BitmapImage();
            //btImage.BeginInit();
            //btImage.UriSource = new Uri(filename, UriKind.Absolute);
            //btImage.EndInit();
            //double w = btImage.Width;
            //double h = btImage.Height;
            //image.Stretch = Stretch.None;
            //image.Source = btImage;
            //if (cbZoom.SelectedIndex > 1) {
            //    image.Width = btImage.Width * cbZoom.SelectedIndex;
            //    image.Height = btImage.Height * cbZoom.SelectedIndex;
            //}

        }


        private void CloseExecuted(object sender, ExecutedRoutedEventArgs e) {
            Close();
        }

        private void image_MouseMove(object sender, MouseEventArgs e) {
            double z = getZoomScale();
            Point p = Mouse.GetPosition(image);
            Txy.Text = ((p.X / z + hScrollBar1)).ToString("##0.#") + " / " + ((p.Y / z + vScrollBar1)).ToString("##0.#");

        }

        int hScrollBar1 = 0;
        int vScrollBar1 = 0;

        private void image_MouseDown(object sender, MouseButtonEventArgs e) {
            if (e.LeftButton == MouseButtonState.Pressed)  {
                int xx, yy,ir;
                double r;
                double z = getZoomScale();
                Point p = Mouse.GetPosition(image);
                int x2 = (int) (p.X / z + hScrollBar1);
                int y2 = (int) (p.Y / z + vScrollBar1);


                switch (CoordsTyp)
                {
                    case C_POINT:     sPoints = x2.ToString() + ", " + y2.ToString();
                                break;
                    case C_RECTANGLE:     if (anzCoords>=2) {   // Linie
                                      anzCoords=0;
                                      sPoints="";
                                }
                               if (anzCoords>0)
                                 sPoints+=",  "+x2.ToString() + ", " + y2.ToString();
                               else
                                   sPoints=x2.ToString() + ", " + y2.ToString();
                               anzCoords++;          
                            break;
                    case C_CIRCLE: if (anzCoords >= 2)
                            {   // Circle
                                anzCoords = 0;
                                sPoints = "";
                            }
                            switch (anzCoords)
                            {
                                case 0:     anzCoords=1;
                                            sPoints=x2.ToString() + ", " + y2.ToString();
                                            xCoord=x2;
                                            yCoord=y2;
                                            break;
                                case 1:    anzCoords=2;
                                            xx = xCoord-x2;
                                            yy = yCoord-y2;
                                            r = Math.Sqrt(xx*xx + yy*yy);
                                            ir = (int) Math.Round(r);
                                            sPoints += ", " + ir.ToString();
                                            break;
                                default:    MessageBox.Show("Fehlerhafter Case-Fall, Modul FCoords, Methode pictureBox1_MouseDown"+
                                            "\r\nanzCoords: " + anzCoords.ToString(), "Fehlerhafter Case-Fall");
                                            break;
                            }
                            break;
                    case C_POLYLINE: anzCoords++;  // Polyline
                            if (anzCoords>1) sPoints+=",  ";
                            sPoints += x2.ToString() + ", " + y2.ToString();
                            break;
                }
                TPoints.Text = sPoints;
            }
        }

        private void mnPoints_Click(object sender, RoutedEventArgs e) {
            setCoordsTyp(C_POINT);
        }

        private void mnRectangle_Click(object sender, RoutedEventArgs e) {
            setCoordsTyp(C_RECTANGLE);
        }

        private void mnCircle_Click(object sender, RoutedEventArgs e) {
            setCoordsTyp(C_CIRCLE);
        }

        private void mnPolyline_Click(object sender, RoutedEventArgs e) {
            setCoordsTyp(C_POLYLINE);
        }


        private void SavefileExecuted(object sender, ExecutedRoutedEventArgs e) {
            bRetCode = true;
            Close();
        }


        private void setCoordsTyp(int index) {
            CoordsTyp = index;
            anzCoords = 0;
            sPoints = "";
            TPoints.Text = "";
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            // e.Cancel = true;
            if (anzCoords > 0 && !bRetCode)
            {
                MessageBoxResult res = Basis.readYesNoCancel("Save the changes?\r\n", "Close window");
                if (res == MessageBoxResult.Cancel) {
                    // Stop closing
                    e.Cancel = true;
                }
                else if (res == MessageBoxResult.Yes)
                {
                    bRetCode = true;
                }
            }
        }

    }
}
